set memory 99m

set matsize 800

use "C:\Documents and Settings\wt231485\Pulpit\var.dta", clear

gen rpkb=pkb/def_CPI

gen rconsumption=consumption/def_CPI

gen lrpkb=ln(rpkb)

gen lrconsumption=ln(rconsumption)

gen lm3=ln(m3)

gen ldef_CPI=ln(def_CPI)

var lrpkb ldef_CPI lrconsumption lm3, exog(_q*)

varsoc lrconsumption lm3 ldef_CPI lrpkb, maxlag(3) /*testing for number of lags in VAR*/

varstable /*testing for VAR stability*/

vargranger /*testing for Granger causality: all-to-all*/

varlmar /*testing for autocorrelation in VAR - it tells you whether you have the sufficient no. of lags*/

/*Impuls response function*/

cap irf drop
irf create irf, set(irf, replace)
irf graph irf, i(lrpkb) r(lrconsumption) /*unique shock of GDP on consumption*/
irf  graph oirf, i(lrpkb) r(lrconsumption) /*and orthogonal shock - a continuous change in the situation*/


/*Forcasting*/

varfcast compute, step(8) dynamic(q(2005.1)) /*do the forecast*/


/*VECM*/

vecrank lrconsumption ldef_CPI lrpkb lm3, lags(3) /*testing for number of cointegrating relations - the Johansen trace test; STATA stops at finding the correct number of relations (i.e. the rank)*/

vec lrconsumption lm3 ldef_CPI lrpkb, rank(3) lags(3) /*the actual VECM*/

vecstable /*testing for VECM stability*/

veclmar /*testing for autocorrelation*/
